package com.juk.apps.lingualpad;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.tanksoftware.io.*;
import com.tanksoftware.io.TSFS.*;

/**
 * LingualPad
 * 
 * This is a small Java notepad type program.  The first version was written in 15min flat.
 * It utalises the TSFS classes in the com.tanksoftware.io package which currently support the
 * reading and writing of UTF-8 Unicode encoded text files.  It was created for use in testing
 * the output of programs, and editing the language translation files.
 *
 *@author William Denniss
 *@version 1.0 31 July 2002
 *
 */

public class LingualPad {
	
	
	private JFrame frame = new JFrame();
	private JPanel panel = new JPanel();
	private JTextArea text = new JTextArea ();
	private JButton load = new JButton ("Load");
	private JButton save = new JButton ("Save");
	private JButton exit = new JButton ("Exit");
	private String filename = "";
	
	public LingualPad (int width, int height) {
		frame.getContentPane().add(panel);
		frame.setSize (width,height);
		frame.setTitle("Lingual Pad");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		int fw = (int) ((double) (Toolkit.getDefaultToolkit().getScreenSize().width - frame.getWidth()) / 2.0);
		int fh = (int) ((double) (Toolkit.getDefaultToolkit().getScreenSize().height - frame.getHeight()) / 2.0);
		if (fw < 0)
			fw = 0;
		if (fh < 0)
			fh = 0;

		frame.setLocation(fw,fh);

		
		JScrollPane scroller = new JScrollPane (text);
		text.setLineWrap(true);
		text.setWrapStyleWord(true);

		panel.setLayout(new BorderLayout ());
		panel.add(scroller, BorderLayout.CENTER);
		panel.add(new JLabel ("by William Denniss"), BorderLayout.SOUTH);
		
		JPanel buttons = new JPanel ();
		panel.add(buttons, BorderLayout.NORTH);
		buttons.add(load);
		buttons.add(save);
		buttons.add(exit);
		
		load.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				fileload();

			}
		});
		
		save.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				savefile();

			}
		});
		
		exit.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				System.exit(0);

			}
		});
		
		
		frame.setVisible(true);
		
	}
	
	public void fileload () {
		
		filename = TSFS.fileChooser(frame, "Open File", null, "", "");
		
		try {
			TSFSFile file = new TSFSFile (filename);
			text.setText(file.getFileContents());
		} catch (IOException e) {
		}
		
	}
	
	public void savefile () {
		try {
			TSFSFile.writeFile (filename, text.getText());
		} catch (IOException e) {
		}
	}
	
	
	public static void main (String [] args) {
		int width;
		int height;
		try {
			width = Integer.parseInt(args[0]);
			height = Integer.parseInt(args[1]);
		} catch (Exception e) {
			width = 500;
			height = 500;
		}			
		new LingualPad (width, height);
	}
	
	
	
	
	
	
}
