package com.juk.gui;

import java.io.Serializable;

public class XYConstraints implements Cloneable, Serializable {
    int x;
    int y;
    int width;
    int height;

    public XYConstraints() {
        this( 0, 0, 0, 0 );
    }

    public XYConstraints( int x, int y, int width, int height ) {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
    }

    public int getX() {
        return x;
    }



    public void setX( int x ) {
        this.x = x;
    }

    public int getY() {
        return y;
    }

    public void setY( int y ) {
        this.y = y;
    }

    public int getWidth() {
        return width;
    }

    public void setWidth( int width ) {
        this.width = width;
    }

    public int getHeight() {
        return height;
    }

    public void setHeight( int height ) {
        this.height = height;
    }

    public int hashCode() {
        return x ^ y * 37 ^ width * 43 ^ height * 47;
    }

    public boolean equals( Object that ) {
        if ( that instanceof XYConstraints ) {
            XYConstraints other = ( XYConstraints ) that;
            return other.x == x && other.y == y && other.width == width && other.height == height;
        } else {
            return false;
        }
    }

    public Object clone() {
        return new XYConstraints( x, y, width, height );
    }

    public String toString() {
        return String.valueOf( ( new StringBuffer( "XYConstraints[" ) ).append( x ).append( "," ).append( y ).append( "," ).append( width ).append( "," ).append( height ).append( "]" ) );
    }
}

//$Log: XYConstraints.java,v $
//Revision 1.1  2002/07/28 16:06:37  divzero
//Added in the sources for XYLayout and XYConstraints.java
//
//Will.
//
//Revision 1.4  2001/06/24 14:00:37  y0014708
//Formatierung
//
//Revision 1.3  2001/06/23 09:53:55  nyvik
//*** empty log message ***
