package com.tanksoftware.apps.onetimenoclist;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.io.*;


import com.tanksoftware.protocol.OneTimeNOCList;
import com.tanksoftware.io.Ini;
import com.tanksoftware.util.WillTank;

/**
 * The main class for the OneTimeNOCList application that processes most of the GUI events.
 *
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */



public class OneTimeNOCListGUIFrame extends JFrame {
	// Program information
	public static final String PROGRAM_NAME = "One Time NOC List";
	public static final String VERSION_NUMBER = "1.3";
	public static final String DATE_CREATED = "04 January 2002";
	public static final String DATE_UPDATED = "05 April 2002";
	public static final String AUTHOR = "William Denniss";

	public static WillTank willTankPanel = new WillTank(PROGRAM_NAME, VERSION_NUMBER, DATE_UPDATED);


  JMenuBar menuBar = new JMenuBar();

  JMenu mainMenu = new JMenu();
  NOCJMenuItem [] mainMenuItems;

  JMenu plainMenu = new JMenu();
  NOCJMenuItem [] plainMenuItems;

  JMenu encMenu = new JMenu();
  NOCJMenuItem [] encMenuItems;

  JMenu keyMenu = new JMenu();
  NOCJMenuItem [] keyMenuItems;

  JMenu operationMenu = new JMenu();
  NOCJMenuItem [] operationMenuItems;

  OneTimeNOCListGUI panel;

  public OneTimeNOCListGUIFrame() {

    try {
      panel = new OneTimeNOCListGUI(this.getWidth(), this.getHeight());
      jbInit();

    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }


	public static void main (String [] args) {
        try {
            UIManager.setLookAndFeel(new com.incors.plaf.kunststoff.KunststoffLookAndFeel());
        } catch (Exception e) {
            System.out.println("Failed to load KunststoffLookAndFeel UI.");
        }


        OneTimeNOCListGUIFrame a = new OneTimeNOCListGUIFrame ();
        a.setTitle("One Time NOC List");
        a.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        a.setSize(570,520);
        a.setVisible(true);


	}

  private void jbInit() throws Exception {

    setIconImage(new ImageIcon("apps/tsicon.gif").getImage());

    willTankPanel.startDialog();

    this.addComponentListener(new NOCFrameListener(panel, this));

    mainMenu.setText("Main");
    mainMenuItems = new NOCJMenuItem [2];
    mainMenuItems[0] = new NOCJMenuItem ("About", "Main");
    mainMenuItems[0].setIcon(new ImageIcon ("data/images/tsicon.png"));

    mainMenuItems[1] = new NOCJMenuItem ("Exit", "Main");
    mainMenuItems[1].setIcon(new ImageIcon ("data/images/blank.png"));

    plainMenu.setText("Plain Text");
    plainMenuItems = new NOCJMenuItem [3];
    plainMenuItems[0] = new NOCJMenuItem ("New", "Plain Text");
    plainMenuItems[1] = new NOCJMenuItem ("Open", "Plain Text");
    plainMenuItems[2] = new NOCJMenuItem ("Save As", "Plain Text");

    plainMenuItems[0].setIcon(new ImageIcon ("data/images/new.png"));
    plainMenuItems[1].setIcon(new ImageIcon ("data/images/open.png"));
    plainMenuItems[2].setIcon(new ImageIcon ("data/images/save.png"));


    encMenu.setText("Encrypted Text");
    encMenuItems = new NOCJMenuItem [3];
    encMenuItems[0] = new NOCJMenuItem ("New", "Encrypted Text");
    encMenuItems[1] = new NOCJMenuItem ("Open", "Encrypted Text");
    encMenuItems[2] = new NOCJMenuItem ("Save As", "Encrypted Text");

    encMenuItems[0].setIcon(new ImageIcon ("data/images/new.png"));
    encMenuItems[1].setIcon(new ImageIcon ("data/images/open.png"));
    encMenuItems[2].setIcon(new ImageIcon ("data/images/save.png"));


    keyMenu.setText("Decrypt Key");
    keyMenuItems = new NOCJMenuItem [3];
    keyMenuItems[0] = new NOCJMenuItem ("New", "Encrypted Text Key");
    keyMenuItems[1] = new NOCJMenuItem ("Open", "Encrypted Text Key");
    keyMenuItems[2] = new NOCJMenuItem ("Save As", "Encrypted Text Key");

    keyMenuItems[0].setIcon(new ImageIcon ("data/images/new.png"));
    keyMenuItems[1].setIcon(new ImageIcon ("data/images/open.png"));
    keyMenuItems[2].setIcon(new ImageIcon ("data/images/save.png"));


    operationMenu.setText("Operations");
    operationMenuItems = new NOCJMenuItem [5];
    operationMenuItems[0] = new NOCJMenuItem ("Encrypt Text", "Operations");
    operationMenuItems[1] = new NOCJMenuItem ("Decrypt Text", "Operations");
    operationMenuItems[2] = new NOCJMenuItem ("Generate Random Key", "Operations");
    operationMenuItems[3] = new NOCJMenuItem ("Generate Key Using Seed", "Operations");
    operationMenuItems[4] = new NOCJMenuItem ("Generate Key Using Password", "Operations");

    menuBar.add(mainMenu);
    mainMenu.add(mainMenuItems[0]);
    mainMenu.addSeparator();
    mainMenu.add(mainMenuItems[1]);

    menuBar.add(plainMenu);
    plainMenu.add(plainMenuItems[0]);
    plainMenu.add(plainMenuItems[1]);
    plainMenu.add(plainMenuItems[2]);

    menuBar.add(encMenu);
    encMenu.add(encMenuItems[0]);
    encMenu.add(encMenuItems[1]);
    encMenu.add(encMenuItems[2]);

    menuBar.add(keyMenu);
    keyMenu.add(keyMenuItems[0]);
    keyMenu.add(keyMenuItems[1]);
    keyMenu.add(keyMenuItems[2]);

    menuBar.add(operationMenu);
    operationMenu.add(operationMenuItems[0]);
    operationMenu.add(operationMenuItems[1]);
    operationMenu.add(operationMenuItems[2]);
    operationMenu.add(operationMenuItems[3]);
    operationMenu.add(operationMenuItems[4]);

    this.setResizable(false);
    this.getContentPane().add(panel, BorderLayout.CENTER);

    this.setJMenuBar(menuBar);

    for (int i = 0; i < menuBar.getMenuCount(); i++) {
      JMenu current = menuBar.getMenu(i);
      for (int k = 0; k < current.getItemCount(); k++) {
        NOCJMenuItem currentItem = (NOCJMenuItem) current.getItem(k);
        //System.out.println(currentItem);
        if (currentItem != null) {

          currentItem.addMouseListener(new NOCMouseAdapter(currentItem) {
              public void mousePressed(MouseEvent evt) {

                if (item.parentText.equals("Main")) {
                  if (item.getText().equals("About")) {
                    System.out.println("One Time NOC List - by William Denniss");
                    willTankPanel.showDialog();
                  } else if (item.getText().equals("Exit")) {
                    System.out.println("Exiting");
                    System.exit(0);
                  }
                } else if (item.parentText.equals("Operations")) {
                System.out.println(item.getText());

                   if (item.getText().equals("Encrypt Text")) {

                        if (panel.encryptedTextKey.getText().length() < panel.plainText.getText().length()) {
                            if (!panel.encryptedTextKey.getText().equals("")) {
                                int result = JOptionPane.showConfirmDialog(null, "Your key isn't big enough.  By continuing a random one will be generated for you Do you want to continue?", "Generate Random Key?", JOptionPane.YES_NO_OPTION);
                                if (result == JOptionPane.NO_OPTION)
                                    return;
                            }

                            panel.encryptedTextKey.setText(OneTimeNOCList.generateRandomKey(panel.plainText.getText()));
                        } else {
                            panel.encryptedTextKey.setText(OneTimeNOCList.formatString(panel.encryptedTextKey.getText(), panel.plainText.getText()));
                        }


                        panel.encryptedText.setText("");

                        BufferedReader brPlain = new BufferedReader(new StringReader(panel.plainText.getText()));
                        BufferedReader brKey = new BufferedReader(new StringReader(panel.encryptedTextKey.getText()));
                        StringWriter encryptedText = new StringWriter ();
                        BufferedWriter bwencrypted = new BufferedWriter(encryptedText);

                        try {
                            OneTimeNOCList.encrypt(brPlain, brKey, bwencrypted);
                        } catch (IOException e) {
                        }

                        panel.encryptedText.setText( encryptedText.toString());

                   } else if (item.getText().equals("Generate Key Using Password")) {
                        String password = JOptionPane.showInputDialog("Please enter password.");



                        String source = panel.encryptedText.getText();
                        if (source.equals(""))
                            source = panel.plainText.getText();
                        panel.encryptedTextKey.setText(OneTimeNOCList. generateRandomKey(source, password,0));
                   } else if (item.getText().equals("Generate Key Using Seed")) {
                        String seedStr = JOptionPane.showInputDialog("Please enter the seed.");
                        String offsetStr = JOptionPane.showInputDialog("Please enter the offset.");
                        long seed = 0;
                        long offset = 0;
                        try {
                            seed = Long.parseLong(seedStr);
                            offset = Long.parseLong(offsetStr);
                        } catch (NumberFormatException e) {
                            JOptionPane.showMessageDialog(null, "You must enter a valid number!", "Invalid Number", JOptionPane.OK_OPTION);
                        }
                        String source = panel.encryptedText.getText();
                        if (source.equals(""))
                            source = panel.plainText.getText();
                        panel.encryptedTextKey.setText(OneTimeNOCList.generateRandomKey(source, seed, offset));
                   } else if (item.getText().equals("Generate Random Key")) {


                     panel.encryptedTextKey.setText(OneTimeNOCList.generateRandomKey(panel.plainText.getText()));

                   } else if (item.getText().equals("Decrypt Text")) {
                        if (!panel.plainText.getText().equals("")) {
                          int result = JOptionPane.showConfirmDialog(null, "By continuing you will overight all current text in the \"Plain Text \" box.  Do you wan't to continue?", "Erase Current Text?", JOptionPane.YES_NO_OPTION);
                          if (result == JOptionPane.NO_OPTION)
                            return;
                        }
                        panel.plainText.setText("");
                        BufferedReader brKey = new BufferedReader(new StringReader(panel.encryptedTextKey.getText()));
                        BufferedReader brEncrypted = new BufferedReader(new StringReader(panel.encryptedText.getText()));
                        StringWriter plainText = new StringWriter ();
                        BufferedWriter bwPlain = new BufferedWriter(plainText);

                        try {
                            OneTimeNOCList.decrypt(bwPlain, brEncrypted, brKey);
                        } catch (IOException e) {
                        }

                        /*
                        for (int l = 0; l < panel.encryptedText.getText().length(); l++) {
                          char [] encrypted = new char [2];

                          try {
                            encrypted[0] = panel.encryptedText.getText().charAt(l);
                            encrypted[1] = panel.encryptedTextKey.getText().charAt(l);
                          } catch (StringIndexOutOfBoundsException e) {
                          }


                          char unencrypted = OneTimeNOCList.decryptChar(encrypted);

                          panel.plainText.setText(panel.plainText.getText() + unencrypted);
                      }
                        */
                        panel.plainText.setText(plainText.toString());
                    }
                } else {
                  JTextArea tmp = new JTextArea ();
                  if (item.parentText.equals("Plain Text"))
                    tmp = panel.plainText;
                  else if (item.parentText.equals("Encrypted Text"))
                    tmp = panel.encryptedText;
                  else if (item.parentText.equals("Encrypted Text Key"))
                    tmp = panel.encryptedTextKey;

                  if (item.getText().equals("New"))
                      tmp.setText("");

                  if (item.getText().equals("Open")) {
                      String filename = getFile("Open File",FileDialog.LOAD, "*.txt");
                      String backup = tmp.getText();
                      try {
                        BufferedReader br;
                        br = new BufferedReader(new FileReader(filename));
                        String line = br.readLine();
                        tmp.setText("");
                        while (line != null) {
                          tmp.setText(tmp.getText() + line + "\n");
                          line = br.readLine();
                        }
                      } catch (IOException e) {
                        tmp.setText(backup);
                        JOptionPane.showMessageDialog(null, "There was an IO error writing to " + filename, "IO Error", JOptionPane.ERROR_MESSAGE );
                      }

                  } if (item.getText().equals("Save As")) {
                      String filename = getFile("Save File As",FileDialog.SAVE, "*.txt");
                      if (filename.lastIndexOf(".") == -1)
                        filename += ".txt";
                        try {
                          PrintWriter pw = new PrintWriter(new FileWriter(filename));
                          pw.print(tmp.getText());
                          pw.close();
                        } catch (IOException e) {
    			  JOptionPane.showMessageDialog(null, "There was an IO error writing to " + filename, "IO Error", JOptionPane.ERROR_MESSAGE );
                        }

                  }
                }

              }
            });
        }
      }

    }

  }

  public String getFile (String title, int flag, String filter) {
 	String filename = "";
        FileDialog file = new FileDialog(this, "Save File", flag);
     //   file.setMode(flag);

        file.setFile("*.txt"); //sets the defult type to *.maze
        file.show(); //shows dialog box
        filename = file.getDirectory() + file.getFile();// + ".txt";
        return filename;
  }
}

class NOCFrameListener implements ComponentListener {
    OneTimeNOCListGUI panel;
    JFrame frame;
    public NOCFrameListener (OneTimeNOCListGUI panel, JFrame frame) {
        this.panel = panel;
        this.frame = frame;
    }

    public void componentResized(ComponentEvent e) {

        System.out.println(e.paramString() + "-" + e.getComponent().getWidth());

        panel.resizePanel(e.getComponent().getWidth(), e.getComponent().getHeight());
  }

    public void componentHidden(ComponentEvent e) {}
    public void componentMoved(ComponentEvent e)  {}

    public void componentShown(ComponentEvent e) {}

}