//WillTank.java
package com.tanksoftware.util;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.*;


/**
 * The Tank Software about box.
 *
 * Created: 1 Apr 2001, Updated 2 Apr 2001
 * This class is to be added to all java programs, invoked when the user presses F5
 * There is a small easter egg:  When the user presses the left or right cursor, the tank arm moves
 * William Denniss has asserted his right under the Copyright, Designs and Patents Act 1988 to be identified as the author of this work
 */





public class WillTank extends JPanel {

	// Program information
	public static final String PROGRAM_NAME = "Tank Software about box";
	public static final String VERSION_NUMBER = "1.1.3";
	public static final String DATE_CREATED = "1 April 2001";
	public static final String DATE_UPDATED = "April 2001";
	public static final String AUTHOR = "William Denniss";


	// Placement variables
	private int angle = 45;
	final private int x = 20;
	private int y = 35;

	private int width = 310;
	private int height = 230;
	final private int startX = 100;
	final private int startY = 50;


	// Set colours
	final private Color programFieldColour = new Color(0x339933);
	final private Color programValueColour = new Color(0x3399CC);
	final private Color tankMainColour = Color.red;
	final private Color tankBoarderColour = Color.black;
	final private Color softwareString = Color.black;
	final private Color designedByString = Color.blue;

	// Program information variables
	private String program;
	private String version;
	private String date;

	private boolean showEasterEgg = true;
	private boolean noInfo = false;
	private boolean drawTankOnly = false;
	private boolean supressTankSoftwareCom = false;

	JFrame willTank = new JFrame();


	/** Constructor: sets the instance variables
	 * @param program The title of the program
	 * @param version The version number of the program
	 * @param date The date the program was last modified
	 */
	public WillTank (String program, String version, String date) {
		this.program = program;
		this.version = version;
		this.date = date;
		noInfo = false;
	}

	/** Constructor: sets the instance variables
	 * @param program The title of the program
	 * @param version The version number of the program
	 * @param date The date the program was last modified
	 */
	public WillTank (String program, String version, String date, boolean showEasterEgg, boolean supressTankSoftwareCom) {
		this.program = program;
		this.version = version;
		this.date = date;
		//this.showEasterEgg = showEasterEgg;
		this.supressTankSoftwareCom = supressTankSoftwareCom;
		noInfo = false;
	}


	/** Constructor: creates an about box with no product information
	 */
	public WillTank () {
		noInfo = true;
		y = y + 20;

	}

	/** Hides the dialog box
	 */
	public void hideDialog () {
		willTank.setVisible(false);
	}

	/** Shows the dialog box
	 */
	public void showDialog () {
		willTank.setVisible(true);
	}

	/** Increase or decrease the dialog width (if the title is too big to fit in the screen).
	 * This must be set before startDialog() is run
	 * @param differWidth the width in pixels to be added to the current width of the frame
	 */
	public void differWidth (int differWidth) {
		width = width + differWidth;
	}

	/** Increase or decrease the dialog height (especially if running from an applet).
	 * This must be set before startDialog() is run
	 * @param differHeight the height in pixels to be added to the current height of the frame
	 */
	public void differHeight (int differHeight) {
		height = height + differHeight;
	}


	/** Initilizes the dialog box
	 */
	public void startDialog () {

		// Get the continer
		JPanel c = new JPanel ();
		willTank.getContentPane().add(c);
		
		c.setLayout(new BorderLayout());
		
		// Add this object (a JPanel) to the content pane
  		c.add(this, BorderLayout.CENTER);


		// Create the button panel
		JPanel buttonPanel = new JPanel ();
		//buttonPanel.setLayout(new BorderLayout());
		JButton okButton = new JButton("OK");

		// Add the ok button, and place it in the middle
		//buttonPanel.add(new JLabel("                                   "),BorderLayout.WEST);
		//buttonPanel.add(new JLabel("                                   "),BorderLayout.EAST);
		buttonPanel.add(okButton);

		c.add(buttonPanel, BorderLayout.SOUTH);

		// Set the frame properties
  		willTank.setTitle("Tank Software");
  		willTank.setBounds(startX, startY, width,height);
  		willTank.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
  		//willTank.setResizable(false);

		// Regester the listeners
		okButton.addActionListener(new ActionListener () {
			public void actionPerformed(ActionEvent e) {
				willTank.setVisible(false);
			}
		});

		//if (showEasterEgg) {
		//	System.out.println("asdf22");
			willTank.addKeyListener(new KeyAdapter( ) {
				public void keyReleased (KeyEvent e) {
					System.out.println("asdf");
					moveArm(e); //detect if the keyboard is pressed and if so, execute the showNextPiece method
				}
			});
		//}

	}

	/** Move the tank arm depending on which key was pressed
	 */
	private void moveArm(KeyEvent e) {
		System.out.println("a");
		int keyCode = e.getKeyCode(); //exctracts the keycode from the KeyEvent

		switch (keyCode) {
		 case KeyEvent.VK_RIGHT:
			angle = angle - 3;
			drawTankOnly = true;
			repaint();
			break;
		 case KeyEvent.VK_LEFT:
			angle = angle + 3;
			drawTankOnly = true;
			repaint();
			break;
		}

		if (angle < 0)
			angle = 180;
		if (angle > 180)
			angle = 0;



	}

	/** Repaints the panel.
	 */
	public void paintComponent (Graphics g) {
		if (!drawTankOnly) {
			tankSoftware (g);
		} else {
			int x2 = x+55;
			g.clearRect(x2-7,y-25,50,35);
			tankDraw(angle, x2, y, tankMainColour, tankBoarderColour, g);
			drawTankOnly = false;
		}

	}

	/** Prints the words "Tank Software" and draws the tank
	 *@param g the Graphics object used by this method
	 */
	private void tankSoftware (Graphics g) {


		// Set the font
		Font tankFont = new Font("Courier New", Font.BOLD, 20);
		g.setFont(tankFont);

		// Draw the "Tank Software" string
		g.setColor(softwareString);
		g.drawString("Tank", x, y);
		g.drawString("Software", x, y + 24);

		// Draw the tank to appear after the "Tank"
		tankDraw(angle,x+55,y,tankMainColour,tankBoarderColour, g);

		// Initilize the position variables for the "developed by" label
		int x2 = x + 120;
		int y2 = y - 6;

		// Draw the "developed by" label
		tankFont = new Font("Times New Roman", Font.BOLD, 26);
		g.setFont(tankFont);

		g.setColor(designedByString);
		g.drawString("juk", x2+25, y2+15);

		g.setColor(Color.black);
		g.fillOval(x2-10,y2+10,10, 10);
		
		// Increase the y value
		y2 = y + 45;

		if (!noInfo) {

			// Set the font
			tankFont = new Font("Courier New", Font.BOLD, 14);
			g.setFont(tankFont);


			// Draw the program fields
			g.setColor(programFieldColour);
			g.drawString("Program: ", x, y2);
			g.drawString("Version: ", x, y2 + tankFont.getSize());
			g.drawString("Date: ", x, y2 + tankFont.getSize() * 2);

			// Draw the program values
			g.setColor(programValueColour);
			g.drawString(program, x+90, y2);
			g.drawString( version, x+90, y2 + tankFont.getSize());
			g.drawString( date, x+90, y2 + tankFont.getSize() * 2);
			y2 = y2 + tankFont.getSize() * 3 + 5;

			if (!supressTankSoftwareCom) {
				// Draw the program fields

				g.setColor(Color.black);
				g.drawString("by William Denniss", x + 20, y2);
				y2 = y2 + tankFont.getSize() * 1 + 10;

				g.setColor(Color.red);
				g.drawString("http://TankSoftware.com/juk/ ", x + 10, y2);
				y2 = y2 + tankFont.getSize() * 1 + 5;

				
			}
		

		}

	}

	/** Draws a tank.  This tank design was created by William Denniss for the Tank Commander program and may not be used without his permission.
	 * <p>
	 * @param angle the angle at which the tank arm will be drawn
	 * @param x the x coordinate
	 * @param y the y coordinate
	 * @param colour the colour of the body and arm of the tank
	 * @param boarderColour the colour of the boarder
 	 * @param g the Graphics component that the tank is to be drawn to
	 */
	public static void tankDraw (int angle, int x, int y, Color colour, Color boarderColour, Graphics g) {

		// Adjust the angle if nessesary
		if (angle > 90 && angle <= 180)
			angle = angle + 180;

		// Convert the angle from degrees to radians
		double a = angle * Math.PI / 180;
		int  verdis = (int) (15 * Math.cos(a));
		int hordis = (int) (15 * Math.sin(a));

		if (angle <= 90) {//'tankr is if the tank is facing right, tankl is if the tank is facing left

			// Draw the body

			g.setColor(colour);

			for (int i = x + 2; i <= x+28; i++ ) {
			   g.drawLine(i-1, y - 1,i + 3, y - 7);
			}

			for (int i = x + 10; i <= x+14; i++ ) {
				g.drawLine(i, y - 9,i + 4, y - 13);
			}


			for (int i = x+24; i <= x + 25; i++) {
				g.drawLine(i, y - 13,i + 3, y - 9);

			}

			g.drawLine(x + 10, y - 8, 14 + x, y - 13);
			g.drawLine (14 + x, y - 13,24 + x, y - 13);
			g.drawLine (24 + x, y - 13,27 + x, y - 8);

			g.fillRect(x + 14, y - 13,12, 5);


			// Draw the arm
			g.drawLine (x + 24, y - 10,x + 24 + verdis, y - 10 - hordis);

			// Draw the boarder

			g.setColor(boarderColour);

			g.drawLine (x, y,27 + x, y);
			g.drawLine (27 + x, y,33 + x, y - 8);
			g.drawLine (x + 6, y - 8,33 + x, y - 8);
			g.drawLine (x, y,x + 6, y - 8);

		} else {

			// Draw the body

			g.setColor(colour);

			for (int i = x + 1; i <= x + 27;i++) {
				g.drawLine (i + 5, y - 1,i, y - 7);
			}
			g.drawLine (x + 5, y - 1,x, y - 7);

			for (int i = x + 5 ; i <= x + 8;i++){
				g.drawLine (i, y - 9,i + 4, y - 13);
			}

			for (int i = x + 18 ; i <= x + 19;i++){
				g.drawLine (i, y - 13,i + 3, y - 9);
			}

			g.drawLine (x + 4, y - 8,8 + x, y - 13);
			g.drawLine (8 + x, y - 13,18 + x, y - 13);
			g.drawLine (18 + x, y - 13,21 + x, y - 8);

			g.fillRect(x + 9, y - 13,12, 5);


			// Draw the arm
			g.drawLine (x + 9, y - 10,x + 9 - verdis, y - 10 + hordis);//, colour

			// Draw the boarder

			g.setColor(boarderColour);

			g.drawLine (x + 6, y,33 + x, y);//, boardercolour
			g.drawLine (x - 1, y - 8,6 + x, y);//, boardercolour
			g.drawLine (x - 1, y - 8,27 + x, y - 8);//, boardercolour
			g.drawLine (x + 27, y - 8,33 + x, y);//, boardercolour



		}
	}

    /**
     * The Tank Software about box JPanel.
     */
	public static class WillTankPanel extends JPanel {

		public void WillTankPanel () {
			repaint();
	//		tankSoftware();
		}



		public void paintComponent (Graphics g) {
			tankSoftware (20, 20, 50, Color.red, Color.black, g);

	//		drawLine(int x1, int y1, int x2, int y2)
	//		drawRect(int x, int y, int width, int height)

		}

		public void tankSoftware (int angle, int x, int y, Color colour, Color boarderColour, Graphics g) {

		Font tankFont = new Font("Courier New", Font.BOLD, 20);

		g.setFont(tankFont);
		g.drawString("Tank", x, y);
		g.drawString("Software", x, y + 24);

		tankDraw(angle,x+55,y,colour,boarderColour,g);

		tankFont = new Font("Times New Roman", Font.BOLD, 16);

		x = x + 120;
		y = y - 6;

		g.setColor(Color.blue);

		g.setFont(tankFont);
		g.drawString("This program", x, y);
		g.drawString("was developed by", x, y + tankFont.getSize() + 0);
		g.drawString("William Denniss", x, y + (tankFont.getSize() + 0) * 2);

		}


		public void tankDraw (int angle, int x, int y, Color colour, Color boarderColour, Graphics g) {
	//  IF boardercolour = 76 THEN boardercolour = colour '76 is a reserved number to indicate that the bordercolour and the colour are the same


	//  'do calculators for drawing the arm
	  if (angle > 90 && angle <= 180)
	  	angle = angle + 180;

	  double a = angle * Math.PI / 180;// 'convert angle from degrees to radians
	 int  verdis = (int) (15 * Math.cos(a));
	  int hordis = (int) (15 * Math.sin(a));

	  if (angle <= 90) {//'tankr is if the tank is facing right, tankl is if the tank is facing left

	//tankdrawr: 'for a tank facing right

	//  'Draw the body of the tank
		g.setColor(colour);
		for (int i = x + 2; i <= x+28; i++ ) {
		   g.drawLine(i, y - 1,i + 4, y - 7);//, colour
		}

		for (int i = x + 10; i <= x+14; i++ ) {
			g.drawLine(i, y - 9,i + 4, y - 13);//, colour
		}


		for (int i = x+24; i <= x + 25; i++) {
			g.drawLine(i, y - 13,i + 3, y - 9);//, colour

		}

	  g.drawLine(x + 10, y - 8, 14 + x, y - 13);//, colour
	  g.drawLine (14 + x, y - 13,24 + x, y - 13);//, colour
	  g.drawLine (24 + x, y - 13,27 + x, y - 8);//, colour

	  g.fillRect(x + 14, y - 13,12, 5);//, colour, BF


	 // 'Draw the arm
	  g.drawLine (x + 24, y - 10,x + 24 + verdis, y - 10 - hordis);//, colour

	g.setColor(boarderColour);
	//  'Draw the border of the tank
	  g.drawLine (x, y,27 + x, y);//, boardercolour
	  g.drawLine (27 + x, y,33 + x, y - 8);//, boardercolour
	  g.drawLine (x + 6, y - 8,33 + x, y - 8);//, boardercolour
	  g.drawLine (x, y,x + 6, y - 8);//, boardercolour


	  } else {
	//tankdrawl: 'for a tank facing left
	 /*
	  'Draw the body of the tank
	  FOR i = x + 1 TO x + 27
	    g.drawLine (i + 5, y - 1,i, y - 7), colour
	  NEXT i
	  g.drawLine (x + 5, y - 1,x, y - 7), boardercolour

	  FOR i = x + 5 TO x + 8
	    g.drawLine (i, y - 9,i + 4, y - 13), colour
	  NEXT i

	  FOR i = x + 18 TO x + 19
	    g.drawLine (i, y - 13,i + 3, y - 9), colour
	  NEXT i

	  g.drawLine (x + 4, y - 8,8 + x, y - 13), colour
	  g.drawLine (8 + x, y - 13,18 + x, y - 13), colour
	  g.drawLine (18 + x, y - 13,21 + x, y - 8), colour

	  g.drawLine (9 + x, y - 13,20 + x, y - 9), colour, BF

	  g.drawLine (x + 6, y,33 + x, y), boardercolour
	  g.drawLine (x - 1, y - 8,6 + x, y), boardercolour
	  g.drawLine (x - 1, y - 8,27 + x, y - 8), boardercolour
	  g.drawLine (x + 27, y - 8,33 + x, y), boardercolour

	  'Draw the arm
	  g.drawLine (x + 9, y - 10,x + 9 - verdis, y - 10 + hordis), colour

	*/
	  }
	  }


	}




}
